stages:
  - build
  - test
  - deploy  # dummy stage to follow the template guidelines
  - review
  - dast
  - fuzz
  - staging
  - canary
  - production
  - incremental rollout 10%
  - incremental rollout 25%
  - incremental rollout 50%
  - incremental rollout 100%
  - performance
  - cleanup

variables:
  SNYK_TOKEN: "wouldBeInAVault"

include:
  - template: Jobs/Dependency-Scanning.gitlab-ci.yml  

synk-report-generation:
  image: node:latest
  extends: .ds-analyzer
  stage: test
  needs: []
  services:
  - openjdk:11-jre-slim-buster
  before_script:
    - apt-get update
    - apt-get install default-jdk -y
  script:
    # Install npm, snyk, and maven
    - npm install -g npm@latest
    - npm install -g snyk
    - npm install maven
    - npm install python3
    # Run snyk auth, snyk monitor, snyk test to break build and out report
    - snyk auth ${SNYK_TOKEN}
    - chmod +x mvnw
    - snyk test --all-projects --json-file-output=snyk_data_file.json || true
     ##assumes you have this locally on your runner or in your repository
    - python3 convert-snyk-to-gitlab.py
  # Save report to artifacts
  artifacts:
    when: always
    paths: 
      - gl-dependency-scanning-report.json
  ## allowing failituyre as I do not actualy have a snyk environment
  allow_failure: true


snyk-converter:
  image: node:latest
  stage: test
  needs: []
  services:
  - openjdk:11-jre-slim-buster
  before_script:
    - apt-get update
    - apt-get install default-jdk -y
    - wget -O sarif-converter https://gitlab.com/ignis-build/sarif-converter/-/releases/permalink/latest/downloads/bin/sarif-converter-linux
    - chmod +x sarif-converter
 ## Run snyk auth, snyk monitor, snyk test to break build and out report
  script:
     Install npm, snyk, and maven
    - npm install -g npm@latest
    - npm install -g snyk
    - npm install maven
    - snyk auth ${SNYK_TOKEN}
    - chmod +x mvnw
    - snyk test --all-projects --sarif-file-output=snyk.sarif  || true
    - ./sarif-converter --type sast snyk_sam.sarif snyk.json
  artifacts:
    reports:
      sast: snyk.json
  ## allowing failure as I do not actualy have a snyk runner environment
  allow_failure: true